/*  GuiTuner 0.05
 *  Copyright (c) 2001 Fabio Checconi <fchecconi@libero.it>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _CONFFILE_H_
#define _CONFFILE_H_

#include <map>
#include <string>
#include <vector>
#include "conferror.h"

namespace Config {
	class ConfFile {
		public:
			ConfFile() throw();
			~ConfFile();

		void load(const char *) throw(Error::ConfError);
		void save(const char *) throw();

		bool getValue(const char *, std::string &) throw();
		bool setValue(const char *, const std::string &) throw();

		private:
		struct Value {
			int linNum;
			std::string content;
		};
		std::map<std::string, Value> table;
		std::vector<std::string> line;
	};
}

#endif

