/*  GuiTuner 0.05
 *  Copyright (c) 2001 Fabio Checconi <fchecconi@libero.it>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _ESDOUTAUDIO_H_
#define _ESDOUTAUDIO_H_

#include <esd.h>
#include "audio.h"

namespace Tuner {
	class Esd: public Audio {
		public:
			Esd() throw(Error::AudioError);
		       ~Esd();

		bool	openDevice(AudioInfo *, bool, bool)
			throw(Error::AudioError);
		bool	closeDevice() throw();

		bool	play(unsigned char *, int) throw(Error::AudioError);
		bool	record(unsigned char *, int) throw(Error::AudioError);

		bool	avail(int *, int *) throw(Error::AudioError);
		bool	free(int *, int *) throw(Error::AudioError);

		bool	sync() throw(Error::AudioError);
		bool	stop() throw(Error::AudioError);

		const AudioInfo *getInfo() throw();

		private:
		static	esd_format_t	readFormat(AudioInfo *);

		static int fd;
		AudioInfo info;
	};

	inline const AudioInfo *Esd::getInfo() throw() { return &info; }
}

#endif

