/*  GuiTuner 0.05
 *  Copyright (c) 2001 Fabio Checconi <fchecconi@libero.it>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _GENCONF_H_
#define _GENCONF_H_

#include <string>
#include "conferror.h"
#include "gui.h"
#include "mainthread.h"
#include "conf.h"

namespace Config {
	class GenConf: public Tuner::Conf {
		public:
			GenConf(int &, char **&) throw(Error::ConfError);
		   ~GenConf();

		Thread::MainThread *createMainThread(Interface::Gui *) throw(std::bad_alloc);

		void save() throw(Error::ConfError);

		private:
		void parseCmdLine(int &, char **&) throw(Error::ConfError);
		void parseEnv() throw(Error::ConfError);

		std::string inConf, outConf;
		Thread::MainThread *thPtr;
	};
}

#endif

