/*  GuiTuner 0.05
 *  Copyright (c) 2001 Fabio Checconi <fchecconi@libero.it>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _MAIN_THREAD_H_
#define _MAIN_THREAD_H_

#include <new>
#include <stdexcept>
#include "gui.h"
#include "audio.h"
#include "calc.h"
#include "posixthread.h"

namespace Thread {
	class MainThread: public PosixThread {
		public:
		enum Command { STOP, PAUSE, CONTINUE };

			MainThread(Interface::Gui * = 0, Tuner::Audio * = 0, Tuner::Calc * = 0,
				unsigned char * = 0, int = 0, int = 0) throw(std::bad_alloc);
		   ~MainThread();

		void reconfigure(Interface::Gui *, Tuner::Audio *, Tuner::Calc *,
			unsigned char * = 0, int = 0, int = 0) throw(std::bad_alloc);
		int main() throw();

		private:
		void adjustBuffers(int) throw();

		Interface::Gui *gui;
		Tuner::Audio *audioDev;
		Tuner::Calc *calc;
		unsigned char *buffer;
		int bufSize;

		unsigned char *auxBuf;
		int auxBufSize, refreshBytes;
		bool paused;
	};
}

#endif

