/*  GuiTuner 0.05
 *  Copyright (c) 2001 Fabio Checconi <fchecconi@libero.it>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _NOTE_H_
#define _NOTE_H_

namespace Tuner {
	enum NamingConv {
		ENGLISH,
		ITALIAN,
		CONV_NUMBER
	};

	class Note {
		public:
			Note(double) throw();
		//   ~Note();

		//Note &operator=(const Note &) throw();

		const char *getName() const throw();
		const int getCents() const throw();

		static NamingConv getNamingConv() throw();
		static void setNamingConv(NamingConv) throw();

		static double getRef() throw();
		static void setRef(double) throw();

		static double getDelta() throw();
		static void setDelta(double) throw();

		private:
		int nameIndex, cents;

		static NamingConv conv;
		static double ref, delta;
	};

	inline const int Note::getCents() const throw() { return cents; }

	inline NamingConv Note::getNamingConv() throw() { return conv; }
	inline void Note::setNamingConv(NamingConv c) throw() { conv = c; }

	inline double Note::getRef() throw() { return ref; }
	inline void Note::setRef(double r) throw() { ref = r; }

	inline double Note::getDelta() throw() { return delta; }
	inline void Note::setDelta(double d) throw() { delta = d; }
}

#endif

