/*  GuiTuner 0.05
 *  Copyright (c) 2001 Fabio Checconi <fchecconi@libero.it>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _OSSAUDIO_H_
#define _OSSAUDIO_H_

#include "audio.h"

namespace Tuner {
	class Oss: public Audio {
		public:
			Oss() throw(Error::AudioError);
		       ~Oss();

		bool	openDevice(AudioInfo *, bool, bool)
				throw(Error::AudioError);
		bool	closeDevice() throw();

		bool	play(unsigned char *, int) throw(Error::AudioError);
		bool	record(unsigned char *, int) throw(Error::AudioError);

		bool	avail(int *, int *) throw(Error::AudioError);
		bool	free(int *, int *) throw(Error::AudioError);

		bool	sync() throw(Error::AudioError);
		bool	stop() throw(Error::AudioError);

		const AudioInfo *getInfo() throw();

		private:
		bool	setFormat(Format *);
		bool	setChannels(Channels *);
		bool	setRate(SamplingRate *);
		bool	setBuffering(int *, int *);
		bool	getBuffering(int *, int *);

		void	throwError(std::string, Error::AudioErrorID,
				std::string) throw(Error::AudioError);

		static int fd;
		OpenMode mode;
		AudioInfo info;
	};

	inline const AudioInfo *Oss::getInfo() throw() { return &info; }
}

#endif

